Index: /CMT/HEAD/source/cmt_parser.cxx
===================================================================
--- /CMT/HEAD/source/cmt_parser.cxx	(revision 458)
+++ /CMT/HEAD/source/cmt_parser.cxx	(revision 459)
@@ -515,4 +515,8 @@
   Me.clear ();
 
+  log << "configure_cmt_message" << log_endl;
+  //configure_cmt_message ();
+  configure_cmt_message (ap);
+
   log << "configure_default_path" << log_endl;
   configure_default_path ();
@@ -873,7 +877,6 @@
 	    {
 	      Me.m_current_version = "v*";
-	      cerr << "#CMT> Warning: "
-		   << "Could not read `" << version_file << "'."
-		   << " Default version " << Me.m_current_version << endl;
+	      CmtMessage::warning ("Could not read `" + version_file + "'."
+				   " Default version `" + Me.m_current_version + "'");
 	    }
 
@@ -943,7 +946,6 @@
 	      if (structuring_style == with_version_directory)
 		{
-		  cerr << "#CMT> Warning: `"
-		       << up_branch << "' is not correct version syntax."
-		    " Assuming it is package name" << endl;
+		  CmtMessage::warning ("`" + up_branch + "' is not correct version syntax."
+				       " Assuming it is package name");
 		}
 	      // No version descriptor
@@ -952,8 +954,7 @@
 	      Me.m_current_package = up_branch;
 	      Me.m_current_version = "v*";
-	      cerr << "#CMT> Warning: "
-		   << "Structuring style used `without_version_directory', `"
-		   << version_file << "' missing."
-		   << " Default version `" << Me.m_current_version << "'" << endl;
+	      CmtMessage::warning ("Structuring style used `without_version_directory'"
+				   ", `" + version_file + "' missing."
+				   " Default version `" + Me.m_current_version + "'");
 	      CmtSystem::dirname (up_dir, Me.m_current_path);
 	      
@@ -979,30 +980,85 @@
 void Cmt::configure_current_structuring_style (const ArgParser& ap)
 {
-  for (int i = ap.argc - 1; i >= 0; i--)
-    {
-      const cmt_string& arg = ap.argv[i];
-      if (arg == "-without_version_directory")
+  cmt_string s;
+  s = CmtSystem::getenv ("CMTSTRUCTURINGSTYLE");
+  if (s == "without_version_directory")
+    {
+      Me.m_current_structuring_style = without_version_directory;
+    }
+  else if (s == "with_version_directory")
+    {
+      Me.m_current_structuring_style = with_version_directory;
+    } 
+
+  CmtSystem::cmt_string_vector flags;
+  Cmt::get_cmt_flags (flags);
+  for (int i = 0; i < flags.size (); i++)
+    {
+      const cmt_string& flag = flags[i];
+      if (flag == "-without_version_directory")
 	{
 	  Me.m_current_structuring_style = without_version_directory;
-	  return;
 	}
-      else if (arg == "-with_version_directory")
+      else if (flag == "-with_version_directory")
 	{
 	  Me.m_current_structuring_style = with_version_directory;
-	  return;
+	} 
+    }
+
+  for (int i = 1; i < ap.argc; i++)
+    {
+      const cmt_string& arg = ap.argv[i];
+      if (arg[0] != '-') break;
+      if (arg == "-without_v" ||
+	  arg == "-without_ve" ||
+	  arg == "-without_ver" ||
+	  arg == "-without_vers" ||
+	  arg == "-without_versi" ||
+	  arg == "-without_versio" ||
+	  arg == "-without_version" ||
+	  arg == "-without_version_" ||
+	  arg == "-without_version_d" ||
+	  arg == "-without_version_di" ||
+	  arg == "-without_version_dir" ||
+	  arg == "-without_version_dire" ||
+	  arg == "-without_version_direc" ||
+	  arg == "-without_version_direct" ||
+	  arg == "-without_version_directo" ||
+	  arg == "-without_version_director" ||
+	  arg == "-without_version_directory")
+	{
+	  Me.m_current_structuring_style = without_version_directory;
+	  //	  if (!CmtSystem::putenv ("CMTSTRUCTURINGSTYLE", "without_version_directory"))
+	  //	    CmtMessage::error ("Cannot set `CMTSTRUCTURINGSTYLE' to"
+	  //			       " `without_version_directory' in the environment");
+	  if (!Cmt::add_cmt_flag ("-without_version_directory"))
+	    CmtMessage::error ("Cannot add flag `-without_version_directory'");
 	}
-    }
-
-  cmt_string s;
-
-  s = CmtSystem::getenv ("CMTSTRUCTURINGSTYLE");
-  if (s == "without_version_directory")
-    {
-      Me.m_current_structuring_style = without_version_directory;
-    }
-  else if (s == "with_version_directory")
-    {
-      Me.m_current_structuring_style = with_version_directory;
-    } 
+      else if (arg == "-with_v" ||
+	       arg == "-with_ve" ||
+	       arg == "-with_ver" ||
+	       arg == "-with_vers" ||
+	       arg == "-with_versi" ||
+	       arg == "-with_versio" ||
+	       arg == "-with_version" ||
+	       arg == "-with_version_" ||
+	       arg == "-with_version_d" ||
+	       arg == "-with_version_di" ||
+	       arg == "-with_version_dir" ||
+	       arg == "-with_version_dire" ||
+	       arg == "-with_version_direc" ||
+	       arg == "-with_version_direct" ||
+	       arg == "-with_version_directo" ||
+	       arg == "-with_version_director" ||
+	       arg == "-with_version_directory")
+	{
+	  Me.m_current_structuring_style = with_version_directory;
+	  //	  if (!CmtSystem::putenv ("CMTSTRUCTURINGSTYLE", "with_version_directory"))
+	  //	    CmtMessage::error ("Cannot set `CMTSTRUCTURINGSTYLE' to"
+	  //			       " `with_version_directory' in the environment");
+	  if (!Cmt::add_cmt_flag ("-with_version_directory"))
+	    CmtMessage::error ("Cannot add flag `-with_version_directory'");
+	}
+    }
 }
 
@@ -1265,4 +1321,137 @@
 
 //----------------------------------------------------------
+//void Cmt::configure_cmt_message ()
+void Cmt::configure_cmt_message (const ArgParser& ap)
+{
+  cmt_string s;
+
+  s = CmtSystem::getenv ("CMTMSGPREFIX");
+  if (s != "")
+    CmtMessage::set_prefix (s);
+
+  s = CmtSystem::getenv ("CMTFATAL");
+  if (s != "")
+    {
+      CmtMessage::set_level (Fatal);
+    }
+
+  s = CmtSystem::getenv ("CMTERROR");
+  if (s != "")
+    {
+      CmtMessage::set_level (Error);
+    }
+
+  s = CmtSystem::getenv ("CMTWARNING");
+  if (s != "")
+    {
+      CmtMessage::set_level (Warning);
+    }
+
+  s = CmtSystem::getenv ("CMTINFO");
+  if (s != "")
+    {
+      CmtMessage::set_level (Info);
+    }
+
+  s = CmtSystem::getenv ("CMTDEBUG");
+  if (s != "")
+    {
+      CmtMessage::set_level (Debug);
+    }
+
+  CmtSystem::cmt_string_vector flags;
+  Cmt::get_cmt_flags (flags);
+  for (int i = 0; i < flags.size (); i++)
+    {
+      const cmt_string& flag = flags[i];
+      if (flag == "-disable_warnings")
+	{
+	  Me.m_disable_warnings = true;
+	  if (CmtMessage::level () <= Warning)
+	    CmtMessage::set_level (Error);
+	}
+      else if (flag == "-quiet")
+	{
+	  Me.m_quiet = true;
+	  if (CmtMessage::level () <= Error)
+	    CmtMessage::set_level (Fatal);
+	}
+      else if (flag == "-warnings")
+	{
+	  Me.m_warnings = true;
+	  if (CmtMessage::level () != Warning)
+	    CmtMessage::set_level (Warning);
+	  //	  if (CmtMessage::level () > Warning)
+	}
+    }
+
+  for (int i = 1; i < ap.argc; i++)
+    {
+      const cmt_string& arg = ap.argv[i];
+      if (arg[0] != '-') break;
+      if (arg == "-d" ||
+	  arg == "-di" ||
+	  arg == "-dis" ||
+	  arg == "-disa" ||
+	  arg == "-disab" ||
+	  arg == "-disabl" ||
+	  arg == "-disable" ||
+	  arg == "-disable_" ||
+	  arg == "-disable_w" ||
+	  arg == "-disable_wa" ||
+	  arg == "-disable_war" ||
+	  arg == "-disable_warn" ||
+	  arg == "-disable_warni" ||
+	  arg == "-disable_warnin" ||
+	  arg == "-disable_warning" ||
+	  arg == "-disable_warnings")
+	{
+	  Me.m_disable_warnings = true;
+	  if (CmtMessage::level () <= Warning)
+	    {
+	      CmtMessage::set_level (Error);
+	      //	      if (!CmtSystem::putenv ("CMTERROR", "1"))
+	      //		CmtMessage::error ("Cannot set `CMTERROR' in the environment");
+	    }
+	  if (!Cmt::add_cmt_flag ("-disable_warnings"))
+	    CmtMessage::error ("Cannot add flag `-disable_warnings'");
+	}
+      else if (arg == "-q" ||
+	       arg == "-qu" ||
+	       arg == "-qui" ||
+	       arg == "-quie" ||
+	       arg == "-quiet")
+	{
+	  Me.m_quiet = true;
+	  if (CmtMessage::level () <= Error)
+	    {
+	      CmtMessage::set_level (Fatal);
+	      //	      if (!CmtSystem::putenv ("CMTFATAL", "1"))
+	      //		CmtMessage::error ("Cannot set `CMTFATAL' in the environment");
+	    }
+	  if (!Cmt::add_cmt_flag ("-quiet"))
+	    CmtMessage::error ("Cannot add flag `-quiet'");
+	}
+      else if (arg == "-warn" ||
+	       arg == "-warni" ||
+	       arg == "-warnin" ||
+	       arg == "-warning" ||
+	       arg == "-warnings")
+	{
+	  Me.m_warnings = true;
+	  //	  if (CmtMessage::level () > Warning)
+	  if (CmtMessage::level () != Warning)
+	    {
+	      CmtMessage::set_level (Warning);
+	      //	      if (!CmtSystem::putenv ("CMTWARNING", "1"))
+	      //		CmtMessage::error ("Cannot set `CMTWARNING' in the environment");
+	    }
+	  if (!Cmt::add_cmt_flag ("-warnings"))
+	    CmtMessage::error ("Cannot add flag `-warnings'");
+	}
+    }
+}
+
+//----------------------------------------------------------
 //
 //   Actions
@@ -1285,5 +1474,6 @@
   if (ap.arguments.size () < 1)
     {
-      cerr << "#CMT> cmt awk <file> <pattern>" << endl;
+      CmtMessage::error ("cmt awk <file> <pattern>");
+      //      cerr << "#CMT> cmt awk <file> <pattern>" << endl;
       return;
     }
@@ -1458,4 +1648,8 @@
           if (!use->located ())
             {
+	      CmtMessage::warning ("package " + use->get_package_name ()
+				   + " " + use->version + " " + use->path
+				   + " not found");
+	      /*
               if (!Me.m_quiet)
                 {
@@ -1465,4 +1659,5 @@
 		    endl;
                 }
+	      */
             }
           else
@@ -1623,10 +1818,16 @@
           if (s.find ("cmt_standalone") != cmt_string::npos)
             {
-              cerr << "#CMT> Currently not in a CMT package" << endl;
+              CmtMessage::warning ("Currently not in a CMT package");
+	      //              cerr << "#CMT> Currently not in a CMT package" << endl;
             }
           else
             {
+	      char num[32]; sprintf (num, "%d/%d", i+1, uses.size ());
+              CmtMessage::error ("Cannot move to the package in " + s
+				 + " (" + num + ")");
+	      /*
               cerr << "#CMT> Cannot move to the package in " << s << " (" << i+1 << "/" 
                    << uses.size () << ")"<< endl;
+	      */
             }
 
@@ -1638,6 +1839,11 @@
       if (CmtLock::check () == CmtLock::locked_by_another_user)
         {
+	  char num[32]; sprintf (num, "%d/%d", i+1, uses.size ());
+	  CmtMessage::warning ("Ignore locked package in " + s
+			       + " (" + num + ")");
+	  /*
           cerr << "#CMT> Ignore locked package in " << s << " (" << i+1 << "/" 
                << uses.size () << ")" << endl;
+	  */
           continue;
         }
@@ -1686,8 +1892,11 @@
 
 
+  if (CmtMessage::active (Error))
+    {
       cout << "#--------------------------------------------------------------" << endl;
       cout << "# Now trying [" << cmd << "] in " << s << " (" << i+1 << "/" << uses.size () 
            << ")" << endl;
       cout << "#--------------------------------------------------------------" << endl;
+    }
 
       if (is_cmt)
@@ -2042,5 +2251,6 @@
       if (!Tag::check_tag_used (tag) && !Symbol::check_tag_used (tag)) 
 	{
-	  cerr << "#CMT> The tag " << t << " is not used in any tag expression. Please check spelling" << endl;
+	  CmtMessage::warning ("The tag " + t + " is not used in any tag expression. Please check spelling");
+	  //	  cerr << "#CMT> The tag " << t << " is not used in any tag expression. Please check spelling" << endl;
 	}
     }
@@ -2062,5 +2272,6 @@
   if (!Tag::check_tag_used (tag) && !Symbol::check_tag_used (tag) && Cmt::get_warnings ()) 
     {
-      cerr << "#CMT> The CMTSITE value " << env << " is not used in any tag expression. Please check spelling" << endl;
+      CmtMessage::warning ("The CMTSITE value " + env + " is not used in any tag expression. Please check spelling");
+      //      cerr << "#CMT> The CMTSITE value " << env << " is not used in any tag expression. Please check spelling" << endl;
     }
 
@@ -2160,4 +2371,6 @@
       if (CmtSystem::test_file ("requirements"))
         {
+	  if (CmtMessage::active (Error))
+	    {
           cout << "------------------------------------------" << endl;
           cout << "Configuring environment for standalone package." << endl;
@@ -2165,4 +2378,5 @@
           cout << "System is " << Me.m_cmt_config << endl;
           cout << "------------------------------------------" << endl;
+	    }
 
           install_test_setup_scripts ();
@@ -2198,5 +2412,6 @@
   if (makes.size () > 0)
     {
-      cout << "Removing all previous make fragments from " << branch << endl;
+      if (CmtMessage::active (Info))
+	cout << "Removing all previous make fragments from " << branch << endl;
 
       for (int i = 0; i < makes.size (); i++)
@@ -2220,6 +2435,9 @@
   if (makes.size () > 0) 
     {
-      cout << "Removing all previous make fragments from "
-           << Me.m_cmt_config << endl; 
+      if (CmtMessage::active (Info))
+	{
+	  cout << "Removing all previous make fragments from "
+	       << Me.m_cmt_config << endl; 
+	}
 
       for (int i = 0; i < makes.size (); i++) 
@@ -2253,5 +2471,6 @@
   if (!reach_current_package ())
     {
-      cout << "Cannot read the requirements file" << endl;
+      CmtMessage::error ("Cannot read the requirements file");
+      //      cout << "Cannot read the requirements file" << endl;
       return;
     }
@@ -2276,14 +2495,17 @@
           if (!CmtSystem::mkdir (branch_name))
             {
-              cout << "Cannot create the " << branch_name <<" branch" << endl;
+              CmtMessage::error ("Cannot create the " + branch_name + " branch");
+	      //              cout << "Cannot create the " << branch_name <<" branch" << endl;
             }
           else
             {
-              cout << "Installing the " << branch_name << " directory" << endl;
+	      if (CmtMessage::active (Info))
+		cout << "Installing the " << branch_name << " directory" << endl;
             }
         }
       else
         {
-          cout << branch_name << " directory already installed" << endl;
+	  if (CmtMessage::active (Info))
+	    cout << branch_name << " directory already installed" << endl;
         }
     }
@@ -2330,4 +2552,6 @@
       if (CmtSystem::test_file ("requirements"))
         {
+	  if (CmtMessage::active (Error))
+	    {
           cout << "------------------------------------------" << endl;
           cout << "Configuring environment for standalone package." << endl;
@@ -2335,5 +2559,5 @@
           cout << "System is "   << Me.m_cmt_config << endl;
           cout << "------------------------------------------" << endl;
-
+	    }
           install_test_setup_scripts ();
           install_test_cleanup_scripts ();
@@ -2379,5 +2603,6 @@
   if (!reach_current_package ())
     {
-      cout << "Cannot read the requirements file" << endl;
+      CmtMessage::error ("Cannot read the requirements file");
+      //      cout << "Cannot read the requirements file" << endl;
       return;
     }
@@ -2401,14 +2626,17 @@
           if (!CmtSystem::mkdir (branch_name))
             {
-              cout << "Cannot create the " << branch_name <<" branch" << endl;
+              CmtMessage::error ("Cannot create the " + branch_name + " branch");
+	      //              cout << "Cannot create the " << branch_name <<" branch" << endl;
             }
           else
             {
-              cout << "Installing the " << branch_name << " directory" << endl;
+	      if (CmtMessage::active (Info))
+		cout << "Installing the " << branch_name << " directory" << endl;
             }
         }
       else
         {
-          cout << branch_name << " directory already installed" << endl;
+	  if (CmtMessage::active (Info))
+	    cout << branch_name << " directory already installed" << endl;
         }
     }
@@ -2456,4 +2684,6 @@
   // Now 'the_path' contains the complete path where the package will be created
 
+  if (CmtMessage::active (Error))
+    {
   cout << "------------------------------------------" << endl;
   cout << "Configuring environment for package " << package <<
@@ -2463,4 +2693,5 @@
   cout << "System is " << Me.m_cmt_config << endl;
   cout << "------------------------------------------" << endl;
+    }
 
   if (!CmtSystem::test_directory (the_path))
@@ -2468,10 +2699,12 @@
       if (!CmtSystem::mkdir (the_path))
         {
-          cout << "Cannot create the path directory" << endl;
+          CmtMessage::error ("Cannot create the path directory");
+	  //          cout << "Cannot create the path directory" << endl;
           return;
         }
       else
         {
-          cout << "Installing the path directory" << endl;
+	  if (CmtMessage::active (Info))
+	    cout << "Installing the path directory" << endl;
         }
     }
@@ -2483,15 +2716,18 @@
       if (!CmtSystem::mkdir (package))
         {
-          cout << "Cannot create the package directory" << endl;
+          CmtMessage::error ("Cannot create the package directory");
+	  //          cout << "Cannot create the package directory" << endl;
           return;
         }
       else
         {
-          cout << "Installing the package directory" << endl;
+	  if (CmtMessage::active (Info))
+	    cout << "Installing the package directory" << endl;
         }
     }
   else
     {
-      cout << "Package directory already installed" << endl;
+      if (CmtMessage::active (Info))
+	cout << "Package directory already installed" << endl;
     }
 
@@ -2528,15 +2764,18 @@
           if (!CmtSystem::mkdir (version))
             {
-              cout << "Cannot create the version directory" << endl;
+              CmtMessage::error ("Cannot create the version directory");
+	      //              cout << "Cannot create the version directory" << endl;
               return;
             }
           else
             {
-              cout << "Installing the version directory" << endl;
+	      if (CmtMessage::active (Info))
+		cout << "Installing the version directory" << endl;
             }
         }
       else
         {
-          cout << "Version directory already installed" << endl;
+	  if (CmtMessage::active (Info))
+	    cout << "Version directory already installed" << endl;
         }
 
@@ -2545,5 +2784,6 @@
   else
     {
-      cout << "Version directory will not be created due to structuring style" << endl;
+      if (CmtMessage::active (Info))
+	cout << "Version directory will not be created due to structuring style" << endl;
     }
 
@@ -2554,5 +2794,6 @@
           if (!CmtSystem::mkdir ("cmt"))
             {
-              cout << "Cannot create the cmt directory" << endl;
+	      CmtMessage::error ("Cannot create the cmt directory");
+//              cout << "Cannot create the cmt directory" << endl;
               return;
             }
@@ -2568,5 +2809,6 @@
                 }
 
-              cout << "Installing the cmt directory" << endl;
+	      if (CmtMessage::active (Info))
+		cout << "Installing the cmt directory" << endl;
             }
         }
@@ -2582,5 +2824,6 @@
             }
           
-          cout << "Mgr directory already installed" << endl;
+	  if (CmtMessage::active (Info))
+	    cout << "Mgr directory already installed" << endl;
         }
     }
@@ -2596,5 +2839,6 @@
         }
 
-      cout << "Cmt directory already installed" << endl;
+      if (CmtMessage::active (Info))
+	cout << "Cmt directory already installed" << endl;
     }
 
@@ -2603,15 +2847,18 @@
       if (!CmtSystem::mkdir ("src"))
         {
-          cout << "Cannot create the src directory" << endl;
+          CmtMessage::error ("Cannot create the src directory");
+	  //          cout << "Cannot create the src directory" << endl;
           return;
         }
       else
         {
-          cout << "Installing the src directory" << endl;
+	  if (CmtMessage::active (Info))
+	    cout << "Installing the src directory" << endl;
         }
     }
   else
     {
-      cout << "src directory already installed" << endl;
+      if (CmtMessage::active (Info))
+	cout << "src directory already installed" << endl;
     }
 
@@ -2801,5 +3048,5 @@
       Symbol::expand (cmd);
 
-      cerr << "Execute action " << ap.arguments[0] << " => " << cmd << endl;
+      CmtMessage::info ("Execute action " + ap.arguments[0] + " => " + cmd);
 
       int status = CmtSystem::execute (cmd);
@@ -2849,5 +3096,6 @@
   if (!CmtSystem::test_file (input))
     {
-      cerr << "#CMT> File " << input << " not found" << endl;
+      CmtMessage::error ("File " + input + " not found");
+      //      cerr << "#CMT> File " << input << " not found" << endl;
       return;
     }
@@ -2864,5 +3112,6 @@
   if (file == NULL)
     {
-      cerr << "#CMT> Cannot write filtered file " << output << endl;
+      CmtMessage::error ("Cannot write filtered file " + output);
+      //      cerr << "#CMT> Cannot write filtered file " << output << endl;
     }
   else
@@ -2896,5 +3145,6 @@
   //(unsused) Use& use = Use::current();
 
-  cerr << "try to lock package " << package << " in " << CmtSystem::pwd () << endl;
+  CmtMessage::info ("try to lock package " + package + " in " + CmtSystem::pwd ());
+  //  cerr << "try to lock package " << package << " in " << CmtSystem::pwd () << endl;
 
   set_standard_macros ();
@@ -2936,4 +3186,6 @@
   CmtSystem::compress_path (the_path);
 
+  if (CmtMessage::active (Info))
+    {
   cout << "------------------------------------------" << endl;
   cout << "Removing package " << package <<
@@ -2943,4 +3195,5 @@
   cout << "System is " << Me.m_cmt_config << endl;
   cout << "------------------------------------------" << endl;
+    }
 
   the_path += CmtSystem::file_separator ();
@@ -2949,5 +3202,6 @@
   if (!CmtSystem::cd (the_path))
     {
-      cerr << "Path " << the_path << " not reachable" << endl;
+      CmtMessage::error ("Path " + the_path + " not reachable");
+      //      cerr << "Path " << the_path << " not reachable" << endl;
       return;
     }
@@ -2957,5 +3211,6 @@
       if (CmtSystem::remove_directory (version))
         {
-          cerr << "Version " << version << " has been removed from " << the_path << endl;
+	  if (CmtMessage::active (Info))
+	    cerr << "Version " << version << " has been removed from " << the_path << endl;
           CmtSystem::cmt_string_vector contents;
           CmtSystem::scan_dir (".", contents);
@@ -2965,5 +3220,6 @@
               if (CmtSystem::remove_directory (package))
                 {
-                  cerr << "Package " << package << " has no more versions. Thus it has been removed."<< endl;
+		  if (CmtMessage::active (Info))
+		    cerr << "Package " << package << " has no more versions. Thus it has been removed."<< endl;
                 }
             }
@@ -2971,5 +3227,6 @@
       else
         {
-          cerr << "Impossible to remove version " << version << " from " << the_path << endl;
+          CmtMessage::warning ("Impossible to remove version " + version + " from " + the_path);
+	  //          cerr << "Impossible to remove version " << version << " from " << the_path << endl;
         }
     }
@@ -2986,21 +3243,27 @@
           if (!CmtSystem::remove_directory ("cmt"))
             {
+	      if (CmtMessage::active (Info))
+		{
               cerr << "Unstructured version " << version
                    << " has been removed from " << the_path << endl;
+		}
             }
           else
             {
-              cerr << "Impossible to remove unstructured version " << version
-                   << " from " << the_path << endl;
+              CmtMessage::warning ("Impossible to remove unstructured version " + version + " from " + the_path);
+	      //              cerr << "Impossible to remove unstructured version " << version
+	      //                   << " from " << the_path << endl;
             }
         }
       else
         {
-          cerr << "Version " << version << " not found" << endl;
+          CmtMessage::warning ("Version " + version + " not found");
+	  //          cerr << "Version " << version << " not found" << endl;
         }
     }
   else
     {
-      cerr << "Version " << version << " not found" << endl;
+      CmtMessage::warning ("Version " + version + " not found");
+      //      cerr << "Version " << version << " not found" << endl;
     }
 }
@@ -3051,4 +3314,8 @@
       if (!use->located ())
         {
+	  CmtMessage::warning ("package " + use->get_package_name ()
+			       + " " + use->version + " " + use->path
+			       + " not found");
+	      /*
           if (!Me.m_quiet)
             {
@@ -3058,4 +3325,5 @@
 		endl;
             }
+	      */
         }
       else
@@ -3185,5 +3453,6 @@
                   if (status != 2) CmtError::set (CmtError::execution_error, s);
 
-                  cerr << "#CMT> Cannot remove the symbolic link " << s << endl;
+                  CmtMessage::warning ("Cannot remove the symbolic link " + s);
+		  //                  cerr << "#CMT> Cannot remove the symbolic link " << s << endl;
 
                   break;
@@ -3218,9 +3487,12 @@
 void Cmt::do_run_sequence (const ArgParser& ap)
 {
-  if (ap.arguments.size () == 0) cerr << "#CMT> run_sequence: no sequence specified" << endl;
+  if (ap.arguments.size () == 0)
+    CmtMessage::warning ("run_sequence: no sequence specified");
+  //cerr << "#CMT> run_sequence: no sequence specified" << endl;
 
   SequenceRunner runner;
 
-  cerr << "# cmt run_sequence: sequence " << ap.arguments[0] << endl;
+  if (CmtMessage::active (Info))
+    cerr << "# cmt run_sequence: sequence " << ap.arguments[0] << endl;
 
   runner.run (ap.arguments[0]);
@@ -3230,5 +3502,7 @@
 void Cmt::do_set_version (const ArgParser& ap)
 {
-  if (ap.arguments.size () == 0) cerr << "#CMT> set version: no version specified" << endl;
+  if (ap.arguments.size () == 0)
+    CmtMessage::warning ("set version: no version specified");
+  //cerr << "#CMT> set version: no version specified" << endl;
 
   const cmt_string& version = ap.arguments[0];
@@ -3238,5 +3512,6 @@
   if (!CmtSystem::is_version_directory (version, v, r, p))
     {
-      cerr << "#CMT> set version " << version << " is not a correct version syntax" << endl;
+      CmtMessage::error ("set version " + version + " is not a correct version syntax");
+      //      cerr << "#CMT> set version " << version << " is not a correct version syntax" << endl;
       return;
     }
@@ -3244,6 +3519,8 @@
   if ((v == -1) || (r == -1) || (p == -1))
     {
-      cerr << "#CMT> set version " << version
-	   << " You cannot use wild card to set a version" << endl;
+      CmtMessage::error ("set version " + version
+			 + " You cannot use wild card to set a version");
+      //      cerr << "#CMT> set version " << version
+      //	   << " You cannot use wild card to set a version" << endl;
       return;
     }
@@ -3258,6 +3535,8 @@
   if (branch != "cmt")
     {
-      cerr << "#CMT> set version " << version << " must be applied in a cmt directory" 
-	   << endl;
+      CmtMessage::error ("set version " + version
+			 + " must be applied in a cmt directory");
+      //      cerr << "#CMT> set version " << version << " must be applied in a cmt directory" 
+      //	   << endl;
       return;
     }
@@ -3268,10 +3547,13 @@
   if (branch == version)
     {
-      cerr << "#CMT> set version " << version << " is already available as a version directory" 
-	   << endl;
+      CmtMessage::warning ("set version " + version
+			   + " is already available as a version directory");
+      //      cerr << "#CMT> set version " << version << " is already available as a version directory" 
+      //	   << endl;
       return;
     }
 
-  cerr << "Writing version file : " << version << endl;
+  CmtMessage::info ("Writing version file : " + version);
+  //  cerr << "Writing version file : " << version << endl;
 
   version.write ("version.cmt");
@@ -4012,5 +4294,6 @@
   // (unused??) Use& use = Use::current();
 
-  cerr << "try to unlock package " << package << " in " << CmtSystem::pwd () << endl;
+  CmtMessage::info ("try to unlock package " + package + " in " + CmtSystem::pwd ());
+  //  cerr << "try to unlock package " << package << " in " << CmtSystem::pwd () << endl;
 
   set_standard_macros ();
@@ -4151,4 +4434,49 @@
 {
   return (Me.m_all_sets_done);
+}
+
+//----------------------------------------------------------
+void Cmt::get_cmt_flags (CmtSystem::cmt_string_vector& flags)
+{
+  CmtSystem::split (CmtSystem::getenv ("CMTFLAGS"), " \t", flags);
+}
+
+//----------------------------------------------------------
+cmt_string Cmt::get_cmt_flags ()
+{
+  return CmtSystem::getenv ("CMTFLAGS");
+}
+
+//----------------------------------------------------------
+bool Cmt::set_cmt_flags (const cmt_string& cmtflags)
+{
+  return CmtSystem::putenv ("CMTFLAGS", cmtflags) ?
+    true :
+    (CmtMessage::error ("Cannot set `CMTFLAGS' to `" + cmtflags +
+			"' in the environment"),
+     false) ;
+}
+
+//----------------------------------------------------------
+bool Cmt::add_cmt_flag (const cmt_string& flag)
+{
+  CmtSystem::cmt_string_vector flags;
+  get_cmt_flags (flags);
+  cmt_string cmtflags;
+  for (int i = 0; i < flags.size (); i++)
+    {
+      if (flags[i] == flag) continue;
+      if (cmtflags == "")
+	cmtflags = flags[i]; 
+      else
+	cmtflags += " " + flags[i]; 
+    }
+
+  if (cmtflags == "")
+    cmtflags = flag; 
+  else
+    cmtflags += " " + flag; 
+
+  return set_cmt_flags (cmtflags);
 }
 
@@ -4311,5 +4639,6 @@
 #endif
 
-  cerr << "Creating cleanup scripts." << endl;
+  if (CmtMessage::active (Error))
+    cerr << "Creating cleanup scripts." << endl;
 
   cmt_string temp;
@@ -4397,5 +4726,6 @@
 #endif
 
-  cerr << "Creating setup scripts." << endl;
+  if (CmtMessage::active (Error))
+    cerr << "Creating setup scripts." << endl;
 
   Use& current_use = Use::current ();
@@ -4511,5 +4841,6 @@
 #endif
 
-  cerr << "Creating cleanup scripts." << endl;
+  if (CmtMessage::active (Error))
+    cerr << "Creating cleanup scripts." << endl;
 
   cmt_string temp;
@@ -4590,5 +4921,6 @@
       if (value != "")
 	{
-	  cerr << "Creating native_version file." << endl;    
+	  if (CmtMessage::active (Info))
+	    cerr << "Creating native_version file." << endl;    
 
 	  FILE* f = fopen ("new.native_version.cmt", "wb");
@@ -4618,5 +4950,6 @@
 #endif
 
-  cerr << "Creating setup scripts." << endl;
+  if (CmtMessage::active (Error))
+    cerr << "Creating setup scripts." << endl;
 
   Use& current_use = Use::current ();
@@ -4804,4 +5137,6 @@
   if (!CmtSystem::cd (Me.m_current_path))
     {
+      CmtMessage::error ("Cannot reach the directory " + Me.m_current_path);
+      /*
       if (!Me.m_quiet)
         {
@@ -4809,4 +5144,5 @@
             Me.m_current_path << endl;
         }
+      */
       CmtError::set (CmtError::package_not_found, "Load> Cannot reach the path directory");
       CmtSystem::cd (Me.m_current_dir);
@@ -4820,4 +5156,6 @@
   if (!CmtSystem::cd (Me.m_current_package))
     {
+      CmtMessage::error ("Cannot reach the package " + Me.m_current_package);
+      /*
       if (!Me.m_quiet)
         {
@@ -4825,4 +5163,5 @@
             Me.m_current_package << endl;
         }
+      */
       CmtError::set (CmtError::package_not_found, "Load> Cannot reach the package directory");
       CmtSystem::cd (Me.m_current_dir);
@@ -4840,4 +5179,6 @@
       if (!CmtSystem::test_directory ("cmt"))
         {
+	  CmtMessage::error ("Cannot reach the version " + Me.m_current_version);
+	  /*
           if (!Me.m_quiet)
             {
@@ -4845,4 +5186,5 @@
                 Me.m_current_version << endl;
             }
+	  */
           CmtError::set (CmtError::package_not_found, "Load> Cannot reach the version directory");
           CmtSystem::cd (Me.m_current_dir);
